clear all;
close all;
Rso=1E-6;
Rs=1E6;
L=6.95E-3;
C=1E-6;
Rr=20;
Vso=1;

dt=1E-5;

Rl=2*L/dt;
Rc=dt/(2*C);


G=[1/Rso+1/Rs -1/Rs 0 0; -1/Rs 1/Rs+1/Rl -1/Rl 0; 0 -1/Rl 1/Rl+1/Rc -1/Rc; 0 0 -1/Rc 1/Rc+1/Rr];

V=zeros(1000,4);
I=zeros(1000,5);


for k=2:1000

if(k>200)
Rs=1E-6;
G=[1/Rso+1/Rs -1/Rs 0 0; -1/Rs 1/Rs+1/Rl -1/Rl 0; 0 -1/Rl 1/Rl+1/Rc -1/Rc; 0 0 -1/Rc 1/Rc+1/Rr];
end

if(k>300)
Rs=1E6;
G=[1/Rso+1/Rs -1/Rs 0 0; -1/Rs 1/Rs+1/Rl -1/Rl 0; 0 -1/Rl 1/Rl+1/Rc -1/Rc; 0 0 -1/Rc 1/Rc+1/Rr];
end

if(k>400)
Rs=1E-6;
G=[1/Rso+1/Rs -1/Rs 0 0; -1/Rs 1/Rs+1/Rl -1/Rl 0; 0 -1/Rl 1/Rl+1/Rc -1/Rc; 0 0 -1/Rc 1/Rc+1/Rr];
end

Iso=Vso/Rso;
Ihl=I(k-1,3)+dt/(2*L)*(V(k-1,2)-V(k-1,3));
Ihc=-2*C/dt*(V(k-1,3)-V(k-1,4))-I(k-1,4);
Ib=[Iso; -Ihl; Ihl-Ihc;Ihc ];
vn=inv(G)*Ib;
V(k,:)=(vn)';
I(k,1)=(0-V(k,1))/Rso;
I(k,2)=(V(k,1)-V(k,2))/Rso;
I(k,3)=(V(k,2)-V(k,3))/Rl+Ihl;
I(k,4)=(V(k,3)-V(k,4))/Rc+Ihc;
I(k,5)=(V(k,4)-0)/Rr;
end

plot(V(:,3)-V(:,4))

